# $Revision: 1.16 $, $Date: 2009/04/13 15:28:35 $
#
# Conditional build:
%bcond_without	javadoc		# don't build javadoc
%if "%{pld_release}" == "ti"
%bcond_without	java_sun	# build with gcj
%else
%bcond_with	java_sun	# build with java-sun
%endif

%include	/usr/lib/rpm/macros.java

%define		srcname		bcel
Summary:	Byte Code Engineering Library
Summary(pl.UTF-8):	Biblioteka do obróbki bajtkodu Javy
Name:		java-bcel
Version:	5.1
Release:	2
License:	Apache v2.0
Group:		Libriaries/Java
# a lot of junk (all other formats) inside -src.tar.gz, use -src.zip
Source0:	http://www.apache.org/dist/jakarta/bcel/source/%{srcname}-%{version}-src.zip
# Source0-md5:	23767d4e735543c25b950ab86c8f56b1
Patch0:		jakarta-%{srcname}-build.patch
Patch1:		jakarta-%{srcname}-manifest.patch
Patch2:		jakarta-%{srcname}-jdk15.patch
URL:		http://jakarta.apache.org/bcel/
BuildRequires:	ant
%{!?with_java_sun:BuildRequires:	java-gcj-compat-devel}
%{?with_java_sun:BuildRequires:	java-sun}
BuildRequires:	java-regexp
BuildRequires:	jpackage-utils
BuildRequires:	rpm >= 4.4.9-56
BuildRequires:	rpm-javaprov
BuildRequires:	rpmbuild(macros) >= 1.300
BuildRequires:	unzip
Requires:	java-regexp
Provides:	jakarta-bcel
Obsoletes:	jakarta-bcel
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The Byte Code Engineering Library (formerly known as JavaClass) is
intended to give users a convenient possibility to analyze, create,
and manipulate (binary) Java class files (those ending with .class).
Classes are represented by objects which contain all the symbolic
information of the given class: methods, fields and byte code
instructions, in particular. Such objects can be read from an existing
file, be transformed by a program (e.g. a class loader at run-time)
and dumped to a file again. An even more interesting application is
the creation of classes from scratch at run-time. The Byte Code
Engineering Library (BCEL) may be also useful if you want to learn
about the Java Virtual Machine (JVM) and the format of Java .class
files. BCEL is already being used successfully in several projects
such as compilers, optimizers, obsfuscators and analysis tools, the
most popular probably being the Xalan XSLT processor at Apache.

%description -l pl.UTF-8
BCEL (Byte Code Engineering Library, poprzednio znana jako JavaClass)
ma umożliwić wygodne analizowanie, tworzenie i obróbkę (binarnych)
plików klas Javy (tych z nazwą kończącą się na .class). Klasy są
reprezentowane przez obiekty zawierające wszystkie symboliczne
informacje o danej klasie, w szczególności metody, pola i instrukcje
bajtkodu. Obiekty te mogą być odczytywane z istniejącego pliku,
przekształcane przez program (np. wczytujący klasy w czasie działania)
i zrzucane z powrotem do pliku. Jeszcze ciekawszym zastosowaniem jest
tworzenie klas od zera w czasie działania programu. Biblioteka BCEL
może być także użyteczna, jeśli chcemy nauczyć się czegoś o maszynie
wirtualnej Javy (JVM) oraz formacie plików .class. BCEL jest używana z
sukcesem w różnych projektach, takich jak kompilatory, optymalizatory,
narzędzia utrudniające analizę oraz narzędzia do analizy, z których
najpopularniejszym jest procesor XSLT Xalan.

%package javadoc
Summary:	Byte Code Engineering Library documentation
Summary(pl.UTF-8):	Dokumentacja do biblioteki do obróbki bajtkodu Javy
Group:		Documentation
Requires:	jpackage-utils
Obsoletes:	jakarta-bcel-doc
Obsoletes:	jakarta-bcel-javadoc

%description javadoc
Byte Code Engineering Library documentation.

%description javadoc -l pl.UTF-8
Dokumentacja do biblioteki do obróbki bajtkodu Javy.

%prep
%setup -q -n bcel-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
find -name '*.jar' | xargs rm -f

%build
CLASSPATH="$(build-classpath regexp)"
export JAVA_HOME="%{java_home}"

%ant jar %{?with_javadoc:apidocs}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_javadir}

cp -p bin/%{srcname}.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}-%{version}.jar
ln -sf %{srcname}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}.jar

%if %{with javadoc}
install -d $RPM_BUILD_ROOT%{_javadocdir}/%{srcname}-%{version}
cp -R docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{srcname}-%{version}
ln -s %{srcname}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{srcname} # ghost symlink
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
ln -nfs %{srcname}-%{version} %{_javadocdir}/%{srcname}

%files
%defattr(644,root,root,755)
%doc LICENSE.txt
%{_javadir}/*.jar

%if %{with javadoc}
%files javadoc
%defattr(644,root,root,755)
%{_javadocdir}/%{srcname}-%{version}
%ghost %{_javadocdir}/%{srcname}
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)

%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: java-bcel.spec,v $
Revision 1.16  2009/04/13 15:28:35  glen
- xargs for less exec calls

Revision 1.15  2009/04/13 15:27:34  glen
- bcond header

Revision 1.14  2009/04/13 15:21:22  pawelz
- javadoc bcond
- unify java package
- added two lines to last commit log

Revision 1.13  2009/04/13 15:15:32  pawelz
- renamed to java-bcel
- jdk bconds
- include java rpm macros
- allow build-classpath to die and break build process

Revision 1.12  2007/02/13 08:06:35  glen
- tabs in preamble

Revision 1.11  2007/02/12 00:48:57  baggins
- converted to UTF-8

Revision 1.10  2006/12/08 01:05:53  glen
- -javadoc R: jpackage-utils for parent dirs; rel 2

Revision 1.9  2006/05/24 10:39:41  qboosh
- Obsoletes for jakarta-bcel-doc

Revision 1.8  2006/05/24 10:36:50  jajcus
- BR: jpackage-utils, rpmbuild(macros) >= 1.300
- P: bcel
- ExclusiveArch for builders with JDK
- API docs installed in %{_javadocdir} and packaged into -javadoc subpackage

Revision 1.7  2006/05/19 11:28:19  jajcus
- s/jakarta-ant/ant/ in BR

Revision 1.6  2005/05/07 13:13:11  qboosh
- updated Source0 URL (but use .zip as current .tar.gz contains a lot of junk)
- added jdk15 patch needed to build using jdk 1.5
- pl unifications

Revision 1.5  2004/07/15 11:58:54  pluto
- use %{_javadir}.
- release 1.

Revision 1.4  2003/08/11 22:46:31  ankry
- cosmetics

Revision 1.3  2003/07/03 22:25:11  qboosh
- separated -doc (over 20 times larger than base package)

Revision 1.2  2003/07/03 18:56:59  qboosh
- pl

Revision 1.1  2003/07/02 11:33:26  pascalek
- initial release
